import java.util.*;
import java.io.*;

public class SingleRead {
    
    public static void main(String[] args) {
	if (args.length != 2) {
	    System.out.println("usage: SingleRead <psg> <reads>");
	    System.exit(0);
	}
	
	String psg = args[0];
	SpliceGraph s = new SpliceGraph(psg);
	String readfile = args[1];
	ArrayList<String> lines = new ArrayList<String>();
	String[] reads_1 = null;
	try {
	    Scanner st = new Scanner(new File(readfile));
	    while (st.hasNextLine()) {
		String line = st.nextLine();
		if (!lines.contains(line)) {
		    lines.add(line);
		}
	    }
	    reads_1 = Utility.StringArray(lines);
	}
	catch (IOException ioe) {
	    System.exit(0);
	}

	//ArrayList[] sg_align = s.readSubPaths(reads);

	double ll = s.getLogLikelihood(reads_1);
	System.out.println("Initial ll (SpliceGraph): "+ll);
	s.learnEM(reads_1,1);
	System.out.println();
	System.out.println();

	//double[] initial = s.getEdgeWeights();
	s.resetEdgeWeights();
	String[] read = null;
	for (int i=0; i<reads_1.length; i++) {
	    read = new String[1];
	    read[0] = reads_1[i];
	    s.learnEM(read,0);
	    s.resetEdgeWeights();
	    for (int j=0; j<reads_1.length; j++) {
		read = new String[2];
		read[0] = reads_1[i];
		//System.out.println(read[0]);
		read[1] = reads_1[j];
		//System.out.println(read[1]);
		s.learnEM(read,0);
		s.resetEdgeWeights();
	    }
	}

	/*double[] a = s.getEdgeWeights();
	double result = 0;
	for (int i=0; i<initial.length; i++) {
	    result += Math.abs(a[i]-initial[i]);
	}
	System.out.println("L1 norm: "+result);
	result = 0;
	for (int i=0; i<initial.length; i++) {
	    result += Math.pow(a[i]-initial[i],2);
	}
	result = Math.sqrt(result);
	System.out.println("L2 norm: "+result);*/
    }

    private static String[] getReads(int[] r, ArrayList<String> s) {
	String[] result = new String[r[r.length-1]+1];
	for (int i=0; i<s.size(); i++) {
	    result[r[i]] = s.get(i);
	}
	return result;
    }

    private static ArrayList[] getAlignments(ArrayList<String> a, int[] r) {
	ArrayList[] result = new ArrayList[r[r.length-1]+1];
	for (int i=0; i<result.length; i++) {
	    result[i] = new ArrayList<Integer[]>();
	}
	for (int i=0; i<a.size(); i++) {
	    String[] align = a.get(i).substring(1).split(":");
	    Integer[] c = new Integer[align.length];
	    for (int j=0; j<align.length; j++) {
		c[j] = Integer.decode(align[j]);
	    }
	    if (!contains(result[r[i]],c)) {
		result[r[i]].add(c);
	    }
	}
	return result;
    }

    private static boolean contains(ArrayList<Integer[]> a, Integer[] b) {
	boolean retval = false;
	for (int i=0; i<a.size(); i++) {
	    if (a.get(i).length == b.length) {
		boolean verify = true;
		for (int j=0; j<a.get(i).length; j++) {
		    if (a.get(i)[j] != b[j]) {
			verify = false;
		    }
		}
		if (verify) {
		    retval = true;
		    break;
		}
	    }
	}
	return retval;
    }
}